'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getScriptsAndArgs = undefined;

var _lodash = require('lodash.remove');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.contains');

var _lodash4 = _interopRequireDefault(_lodash3);

var _shellEscape = require('shell-escape');

var _shellEscape2 = _interopRequireDefault(_shellEscape);

var _lodash5 = require('lodash.isempty');

var _lodash6 = _interopRequireDefault(_lodash5);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.getScriptsAndArgs = getScriptsAndArgs;


function getScriptsAndArgs(program) {
  var scripts = void 0,
      args = void 0,
      parallel = void 0;
  if (!(0, _lodash6.default)(program.parallel)) {
    scripts = program.parallel.split(',');
    args = getArgs(program.args, program.rawArgs, scripts);
    parallel = true;
  } else {
    scripts = program.args[0].split(',');
    args = getArgs(program.args.slice(1), program.rawArgs, scripts);
    parallel = false;
  }
  return { scripts: scripts, args: args, parallel: parallel };
}

function getArgs(args, rawArgs, scripts) {
  var allArgs = rawArgs.slice(2);
  var psArgs = ['-p', '--parallel', '-c', '--config'];
  var psFlags = ['-s', '--silent'];
  var cleanedArgs = (0, _lodash2.default)(allArgs, function (item, index, arry) {
    var isArgOrFlag = (0, _lodash4.default)(psArgs, item) || (0, _lodash4.default)(psFlags, item);
    var isArgValue = (0, _lodash4.default)(psArgs, arry[index - 1]);
    var isScript = (0, _lodash4.default)(scripts, item);
    return !isArgOrFlag && !isArgValue && !isScript;
  });
  return (0, _shellEscape2.default)(cleanedArgs);
}